// AUTHOR
//
//	Frederic Boulanger, Supelec
//
//	Internet:	Frederic.Boulanger@supelec.fr
//	Mail: Supelec - Service Informatique
//				Plateau de Moulon
//				91192 Gif-sur-Yvette Cedex
//				France
//	Voice: (33 1) 69 85 14 91
//	Fax:   (33 1) 69 85 12 34
//

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

int main(int argc, char** argv) {
	char command[256];
	char *simprog = 0;
	char *interfprog = 0;
	char *ext = 0;
	int selfsim = 0;
	int fdin[2]; /* entree du pere = stdout et stderr du fils */
	int fdout[2]; /* sortie du pere = stdin du fils */
	
	if ((argc < 2)||(argc > 4)){
		fprintf(stderr,"# usage: %s [-s] <simprog> [<interfprog>]\n", argv[0]);
		return 1;
	}
	if (strcmp(argv[1],"-s") == 0) {
		selfsim = 1;
		if (argc < 3)  {
			fprintf(stderr,"# usage: %s [-s] <simprog> [<interfprog>]\n", argv[0]);
			return 1;
		} else {
			simprog = argv[2];
			interfprog = argv[0];
		}
	} else {
		simprog = argv[1];
		if (argc == 3)
			interfprog = argv[2];
		else
			interfprog = simprog;
	}
	
	ext = getenv("SIMSHELL_EXTENSION");
	if (ext == 0)
		ext = "tcl";
	
	pipe(fdin);	/* Creation des pipes: fdin va du pere (interface) vers le fils */
	pipe(fdout);/* fdout va du fils (programme a simuler) vers le pere */
	
	if (fork() == 0)  {	/* cote fils du fork */
		close(fdin[0]);		/* On ferme les fichiers que l'on n'utilise pas */
		close(fdout[1]);
		
		/* On met dans command la ligne de commande pour sh. Par example, si
		   fdout[0] = 5, fdin[1] = 3 et argv[1] = "simul", on aura:
		   simul <&5 >&3 2>&3
		   ce qui execute "simul" avec stdin redirige sur le descripteur de fichier 5,
		   et stout et stderr rediriges sur le descripteur de fichier 3
		*/
		
		sprintf(command,"%s <&%d >&%d 2>&%d", simprog, fdout[0], fdin[1], fdin[1]);
		system(command);
	} else {	/* cote pere du fork */
		close(fdin[1]);
		close(fdout[0]);
		
		sprintf(command,"%s.%s <&%d >&%d", interfprog, ext, fdin[0], fdout[1]);
		system(command);
	}
	return 0;
}

	