#!/usr/local/bin/wish -f

set RBWIDTH 10
set IDWIDTH 20


# mode par defaut pour les radio boutons

proc Init {} {
  global PresenceSignaux ValeurSignaux PureInput Input PureOutput Output
 
# Get protocol
  set dummy [gets stdin]
#  puts stderr "#$dummy"
# Chose concise mode
  puts "-"
  flush stdout
# Skip clock declaration (we know there is only one clock)
  set dummy [gets stdin]
#  puts stderr "#$dummy"
  set s [gets stdin]
#  puts stderr "#$s"
  set i 0
  set o 0
  while {[string compare $s ">"]} {
  	set n [lindex $s 2]
  	regexp {(.*)_[0-9]+} $n dummy sn
  	switch [lindex $s 0] {
  		"+" {lappend Input $sn; set PureInput($i) 1; incr i}
  		"i" {lappend Input $sn; set PureInput($i) 0; incr i}
  		"*" {lappend Output $sn; set PureOutput($o) 1; incr o}
  		"o" {lappend Output $sn; set PureOutput($o) 0; incr o}
  	}
  	set s [gets stdin]
#  	puts stderr "#$s"
  }
  for {set i 0} {$i < [llength $Input]} {incr i} {
  	if {$PureInput($i)} {
  		set PresenceSignaux(i$i)  -
      set ValeurSignaux(i$i) ""
    } else {
      set PresenceSignaux(i$i)  -
      set ValeurSignaux(i$i) Undef
    }
  }
  for {set i 0} {$i < [llength $Output]} {incr i} {
  	if {$PureOutput($i)} {
  		set PresenceSignaux(o$i)  -
      set ValeurSignaux(o$i) ""
    } else {
      set PresenceSignaux(o$i)  -
      set ValeurSignaux(o$i) Undef
    }
  }
}

Init


# fenetres

frame .fin -borderwidth 2 -relief groove

set listentree ""

for {set i 0} {$i < [llength $Input]} {incr i} {
	if {$PureInput($i)} {
		frame .fin.pe$i
		radiobutton .fin.pe$i.presence -text [lindex $Input $i] -width $RBWIDTH -variable PresenceSignaux(i$i) -value "+" \
		-command "puts stdout \"? 0 $i +\"; flush stdout;gets stdin; .fin.pe$i.presence configure -state normal"
		label .fin.pe$i.vide -width $IDWIDTH
		pack .fin.pe$i.presence .fin.pe$i.vide -side left  -fill x -padx 5 -pady 2 
		lappend listentree .fin.pe$i
	} else {
		frame .fin.e$i 
		radiobutton .fin.e$i.presence -text [lindex $Input $i] -width $RBWIDTH -variable PresenceSignaux(i$i)  -value "+" \
		-command "puts stdout \"? 0 $i \$t${i}val\"; flush stdout;gets stdin; .fin.e$i.presence configure -state normal"
		entry .fin.e$i.valeur -textvariable t${i}val -relief sunken -width $IDWIDTH
		pack .fin.e$i.presence .fin.e$i.valeur -side left  -fill x -padx 5 -pady 2 
		
		bind .fin.e$i.valeur <Return> "puts stdout \"? 0 $i \$t${i}val\"; flush stdout; gets stdin; set PresenceSignaux(i$i) +"
		lappend listentree .fin.e$i
	}
}

eval "pack $listentree -side top  -pady 5"

frame .fout -borderwidth 2 -relief groove

set listsortie ""
for {set i 0} {$i < [llength $Output]} {incr i} {
	if {$PureOutput($i)} {
	  frame .fout.ps$i
	  radiobutton .fout.ps$i.presence -text [lindex $Output $i] -width $RBWIDTH -variable PresenceSignaux(o$i) -value "+" -relief flat \
	  -command ".fout.ps$i.presence configure -state normal"
	  label .fout.ps$i.valeur -relief flat -textvariable ValeurSignaux(o$i) -width $IDWIDTH
	  pack .fout.ps$i.presence .fout.ps$i.valeur -side left -fill x  -padx 5 -pady 2 
	  lappend listsortie .fout.ps$i
	} else {
	  frame .fout.s$i
	  radiobutton .fout.s$i.presence -text [lindex $Output $i] -width $RBWIDTH -variable PresenceSignaux(o$i) -value "+" -relief flat \
	  -command ".fout.s$i.presence configure -state normal"
	  label .fout.s$i.valeur -relief flat -textvariable ValeurSignaux(o$i) -width $IDWIDTH -bg red
	  pack .fout.s$i.presence .fout.s$i.valeur -side left  -fill x -padx 5 -pady 2 
	  lappend listsortie .fout.s$i
	}
}

eval "pack $listsortie -side top  -pady 5"

button .b -text tick -command "schedule"

# put a "." to stdout before exiting. This terminates the simulation
# If you do not put this ".", the child process will keep running!
button .q -text quit -command {puts "."; flush stdout; exit}
pack .fin .fout .b .q -fill x -padx 5 -pady 2 

proc reset {} {
	global PresenceSignaux
	foreach s [array names PresenceSignaux] {
		set PresenceSignaux($s) "-"
	}
}

proc schedule {} {
  global PresenceSignaux ValeurSignaux PureOutput

	# Go for next tick
	puts "' 0"
	flush stdout
	reset
	set s [gets stdin]
#	puts stderr "#$s"
	while {[string compare $s ">"]} {
		set i [lindex $s 2]
		set PresenceSignaux(o$i) "+"
		if {! $PureOutput($i)} {
			set ValeurSignaux(o$i) [lindex $s 3]
		}
		set s [gets stdin]
#		puts stderr "#$s"
	}
}



